
<template>
    <div class="app-view-layout app-view-layout__apploginview app-login-view" v-loading="isLayoutLoadding" :style="{height: '100%', width: '100%','display': 'flex', 'flex-direction': 'column'}">
        <template v-if="!isLayoutLoadding">
    <app-standard-container name="page_container" :isMultiContainer="false" :layoutModelDetails="layoutModelDetails">
        <template #container1>
    <app-standard-container name="container1" :isMultiContainer="false" :layoutModelDetails="layoutModelDetails">
        <template #auth_orgpick>
        <app-login-org name="auth_orgpick" :layoutModelDetails="layoutModelDetails" :value="layoutData.auth_orgpick" @valueChange="handleValueChange" />
        </template>
        <template #userid>
        <app-login-input class="app-login-user" name="userid" :layoutModelDetails="layoutModelDetails" :value="layoutData.userid" defaultIcon="ios-contact" @valueChange="handleValueChange" />
        </template>
        <template #auth_password>
        <app-login-input class="app-login-password" name="auth_password" defaultType="password" :layoutModelDetails="layoutModelDetails" :value="layoutData.auth_password" defaultIcon="ios-key" @valueChange="handleValueChange" />
        </template>
        <template #container2>
    <app-standard-container name="container2" :isMultiContainer="false" :layoutModelDetails="layoutModelDetails">
        <template #auth_loginbutton1>
        <app-login-button class="app-login-button" name="auth_loginbutton1" :layoutModelDetails="layoutModelDetails" @itemClick="handleButtonClick" />
        </template>
        <template #auth_resetinput1>
        <app-login-button class="app-reset-button" name="auth_resetinput1" :layoutModelDetails="layoutModelDetails" @itemClick="handleButtonClick" />
        </template>
    </app-standard-container>
        </template>
        <template #auth_captcha1>
        <app-login-captcha name="auth_captcha1" :layoutModelDetails="layoutModelDetails" :value="layoutData.auth_captcha1" @valueChange="handleValueChange" />
        </template>
        <template #auth_verificationcode>
        <app-login-note-verify name="auth_verificationcode" :layoutModelDetails="layoutModelDetails" :value="layoutData.auth_verificationcode" @valueChange="handleValueChange" />
        </template>
        <template #auth_sso1>
        <app-login-third name="auth_sso1" :layoutModelDetails="layoutModelDetails" :value="layoutData.auth_sso1" />
        </template>
        <template #auth_logout1>
        <app-login-button class="app-logout-button" name="auth_logout1" :layoutModelDetails="layoutModelDetails" @itemClick="handleButtonClick" />
        </template>
        <template #auth_loginmsg>
        <app-login-message name="auth_loginmsg" :layoutModelDetails="layoutModelDetails" :value="layoutData.auth_loginmsg" />
        </template>
    </app-standard-container>
        </template>
    </app-standard-container>
        </template>
    </div>
</template>

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch,Inject } from 'vue-property-decorator';
import { UIActionTool, Util } from '@/utils';
import { AppMessageBox } from '@/utils/app-message-box/app-message-box';
import NavDataService from '@/service/app/navdata-service';
import { Subject,Subscription } from 'rxjs';


import { PanelContainerModel, PanelRawitemModel, PanelFieldModel, PanelControlModel, PanelButtonModel, PanelUserControlModel, PanelTabPanelModel, PanelTabPageModel, PanelCtrlPosModel} from '@/model/panel-detail';

import { Environment } from '@/environments/environment';


@Component({
    components: {
    },
})
export default class AppLoginViewBase extends Vue {
    
    /**
     * 数据变化
     *
     * @param {*} val
     * @returns {*}
     * @memberof AppLoginViewBase
     */
    @Emit() 
    public viewDatasChange(val: any):any {
        return val;
    }

    /**
     * 传入视图上下文
     *
     * @type {string}
     * @memberof AppLoginViewBase
     */
    @Prop() public viewdata!: string;

    /**
     * 传入视图参数
     *
     * @type {string}
     * @memberof AppLoginViewBase
     */
    @Prop() public viewparam!: string;

    /**
     * 视图默认使用
     *
     * @type {boolean}
     * @memberof AppLoginViewBase
     */
    @Prop({ default: true }) public viewDefaultUsage!: boolean;

    /**
     * 视图默认使用
     *
     * @type {string}
     * @memberof AppLoginViewBase
     */
    @Inject({from:'navModel',default: 'tab'})
    public navModel!:string;

	/**
	 * 视图标识
	 *
	 * @type {string}
	 * @memberof AppLoginViewBase
	 */
	public viewtag: string = 'DDD1152C-0A9F-44C5-82FA-7F6A469C5569';

    /**
	 * 视图类型
	 *
	 * @type {string}
	 * @memberof AppLoginViewBase
	 */
	public viewType: string = 'APPLOGINVIEW';

	/**
	 * 自定义视图导航上下文集合
	 *
	 * @type {*}
	 * @memberof AppLoginViewBase
	 */
    public customViewNavContexts:any ={
    };

	/**
	 * 自定义视图导航参数集合
	 *
	 * @type {*}
	 * @memberof AppLoginViewBase
	 */
    public customViewParams:any ={
    };

    /**
     * 视图模型数据
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public model: any = {
        srfCaption: 'app.views.apploginview.caption',
        srfTitle: 'app.views.apploginview.title',
        srfSubTitle: 'app.views.apploginview.subtitle',
        dataInfo: ''
    }

    /**
     * 视图参数变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof AppLoginViewBase
     */
    @Watch('viewparam',{immediate: true, deep: true})
    onParamData(newVal: any, oldVal: any) {
        if(newVal){
            this.viewparams = {};
            if(typeof newVal == 'string') {
                Object.assign(this.viewparams, JSON.parse(this.viewparam));
            }else{
                this.viewparams = Util.deepCopy(this.viewparam);
            }
            
        } 
    }

    /**
     * 处理应用上下文变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof AppLoginViewBase
     */
    @Watch('viewdata')
    onViewData(newVal: any, oldVal: any) {
        const _this: any = this;
        
        if (!Object.is(newVal, oldVal) && _this.engine) {
            this.$nextTick(()=>{
              _this.parseViewParam();
              _this.engine.load();
            });
        } else if(!Object.is(newVal, oldVal) && _this.refresh && _this.refresh instanceof Function) {
            _this.refresh();
        }
    }

    /**
     * 容器模型
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public containerModel: any = {
    };

    /**
     * 视图操作参数
     *
     * @type {*}
     * @readonly
     * @memberof AppLoginViewBase
     */
    public viewCtx: any = {};

    /**
     *  计数器刷新
     *
     * @memberof AppLoginViewBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }

    /**
     * 视图状态订阅对象
     *
     * @public
     * @type {Subject<{action: string, data: any}>}
     * @memberof AppLoginViewBase
     */
    public viewState: Subject<ViewState> = new Subject();

    /**
     * 视图布局顶级成员名称
     *
     * @public
     * @memberof AppLoginViewBase
     */
    public rootLayoutDetailNames: string[] = [ 'page_container' ];

    /**
     * 视图布局面板项模型对象
     *
     * @public
     * @memberof AppLoginViewBase
     */
    public layoutItems:any = {
        auth_orgpick:{ name: 'auth_orgpick', type: 'VIEWLAYOUT', caption: '组织', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'AUTH_ORGPICK', dataItemName:'', },
        userid:{ name: 'userid', type: 'VIEWLAYOUT', caption: '用户名', isShowCaption: false, sysCss: 'greenToolBar', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'OUTERMEDIUM', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'AUTH_USERID', dataItemName:'', },
        auth_password:{ name: 'auth_password', type: 'VIEWLAYOUT', caption: '密码', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'OUTERMEDIUM', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'AUTH_PASSWORD', dataItemName:'', },
        auth_loginbutton1:{ name: 'auth_loginbutton1', type: 'VIEWLAYOUT', caption: '登陆', isShowCaption: true, sysCss: 'deepskyblueToolBar', itemType: 'BUTTON', itemStyle: 'PRIMARY', sysImage:{ iconcls: 'fa fa-refresh', imagePath:'', rawContent: '' }, visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:175, widthMode:'PX', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'CENTER', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container2', panel: this , buttonStyle: 'PRIMARY', borderStyle: '', iconAlign: '', uiAction: { actiontarget: '', noprivdisplaymode: 2, dataaccaction: '', visabled: true, disabled: false }, predefinedType: 'APP_LOGIN', renderMode: '', },
        auth_resetinput1:{ name: 'auth_resetinput1', type: 'VIEWLAYOUT', caption: '重置', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:175, widthMode:'PX', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'CENTER', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container2', panel: this , buttonStyle: 'DEFAULT', borderStyle: '', iconAlign: '', uiAction: { actiontarget: '', noprivdisplaymode: 2, dataaccaction: '', visabled: true, disabled: false }, predefinedType: 'DATA_CANCELCHANGES', renderMode: '', },
        container2:{ name: 'container2', type: 'VIEWLAYOUT', caption: '容器', titleBarCloseMode: 0, isShowCaption: false, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'FLEX', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:100, widthMode:'PERCENTAGE', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'OUTERLARGE', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'space-around',dir:'row',vAlign:'center'}, parentName: 'container1', panel: this , details:['auth_loginbutton1','auth_resetinput1'] , dataRegionType: 'INHERIT' },
        auth_captcha1:{ name: 'auth_captcha1', type: 'VIEWLAYOUT', caption: '人机识别', isShowCaption: true, sysCss: '', itemType: 'USERCONTROL', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'OUTERMEDIUM', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this },
        auth_verificationcode:{ name: 'auth_verificationcode', type: 'VIEWLAYOUT', caption: '短信验证码', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'OUTERMEDIUM', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'AUTH_VERIFICATIONCODE', dataItemName:'', },
        auth_sso1:{ name: 'auth_sso1', type: 'VIEWLAYOUT', caption: '第三方登陆', isShowCaption: true, sysCss: '', itemType: 'USERCONTROL', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'OUTERMEDIUM', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this },
        auth_logout1:{ name: 'auth_logout1', type: 'VIEWLAYOUT', caption: '登出', isShowCaption: true, sysCss: '', itemType: 'BUTTON', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'OUTERMEDIUM', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , buttonStyle: 'DEFAULT', borderStyle: '', iconAlign: '', uiAction: { actiontarget: '', noprivdisplaymode: 2, dataaccaction: '', visabled: true, disabled: false }, predefinedType: 'APP_LOGOUT', renderMode: '', },
        auth_loginmsg:{ name: 'auth_loginmsg', type: 'VIEWLAYOUT', caption: '登陆校验信息', isShowCaption: false, sysCss: '', itemType: 'FIELD', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'OUTERMEDIUM', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , required: false, fieldState: '0', predefinedType: 'AUTH_LOGINMSG', renderMode: '', dataItemName:'', wrapMode:'', vAlign:'', hAlign:'', },
        container1:{ name: 'container1', type: 'VIEWLAYOUT', caption: '容器', titleBarCloseMode: 0, isShowCaption: false, sysCss: 'login-bg', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'FLEX', layoutPos:'', layoutHeight:600, heightMode:'PX', layoutWidth:450, widthMode:'PX', spacingBottom:'INNERLARGE', spacingLeft:'INNERLARGE', spacingRight:'INNERLARGE', spacingTop:'INNERLARGE', hAlignSelf:'CENTER', vAlignSelf:'MIDDLE', flexGrow:-1, flexParams:{align:'',dir:'column',vAlign:''}, parentName: 'page_container', panel: this , details:['auth_orgpick','userid','auth_password','container2','auth_captcha1','auth_verificationcode','auth_sso1','auth_logout1','auth_loginmsg'] , dataRegionType: 'INHERIT' },
        page_container:{ name: 'page_container', type: 'VIEWLAYOUT', caption: '图片背景容器', titleBarCloseMode: 0, isShowCaption: false, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', sysImage:{ iconcls: '', imagePath:'/assets/img/login_bg.png', rawContent: '' }, visible: true, disabled: false, layout:'FLEX', layoutPos:'', layoutHeight:100, heightMode:'PERCENTAGE', layoutWidth:100, widthMode:'PERCENTAGE', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, panel: this , details:['container1'] , dataRegionType: 'INHERIT' }
    }

    /**
     * 布局面板是否加载
     *
     * @public
     * @memberof AppLoginViewBase
     */
    public isLayoutLoadding: boolean = false;

    /**
     * 布局面板数据
     *
     * @public
     * @memberof AppLoginViewBase
     */
    public layoutData:any = {};

    /**
     * 布局面板模型对象
     *
     * @public
     * @memberof AppLoginViewBase
     */
    public layoutModelDetails:any = {};

    /**
     *  初始化布局
     *
     *  @public
     *  @memberof AppLoginViewBase
     */
    public async initLayout() {
        if (this.rootLayoutDetailNames.length > 0) {
            for (let i = 0; i < this.rootLayoutDetailNames.length; i++) {
                const name = this.rootLayoutDetailNames[i];
                const rootItem = this.layoutItems[name];
                if (!rootItem) {
                    return;
                }
                await this.initLayoutItem(rootItem);
            }
        }
        return true;
    }

    /**
     *  初始化布局项
     *
     *  @public
     *  @memberof AppLoginViewBase
     */
    public async initLayoutItem(layoutModelItem: any, index: number = 0) {
        const { name } = layoutModelItem;
        const layoutModelDetail = Util.getLayoutItemInstance(layoutModelItem);
        if (!index) {
            await layoutModelDetail.load(this.context, this.viewparams);
            this.$set(this.layoutModelDetails, name, layoutModelDetail);
            this.$set(this.layoutData, name, layoutModelDetail.getData());
        } else {
            layoutModelDetail.setIndex(index);
            await layoutModelDetail.load(this.context, this.viewparams);
            this.$set(this.layoutModelDetails, `${name}_${index}`, layoutModelDetail);
            this.$set(this.layoutData, `${name}_${index}`, layoutModelDetail.getData());
        }
        if (layoutModelDetail && layoutModelDetail.details) {
            if (layoutModelDetail.dataRegionType === 'MULTIDATA') {
                const multiData = layoutModelDetail.getData();
                if (multiData && multiData.length > 0) {
                    for (let i = 0; i < multiData.length; i++) {
                        for (let j = 0; j < layoutModelDetail.details.length; j++) {
                            const key = layoutModelDetail.details[j];
                            if (this.layoutItems[key]) {
                                await this.initLayoutItem(this.layoutItems[key], i);
                            }
                        }
                    }
                }
            } else {
                for (let i = 0; i < layoutModelDetail.details.length; i++) {
                    const key = layoutModelDetail.details[i];
                    if (this.layoutItems[key]) {
                        await this.initLayoutItem(this.layoutItems[key],index);
                    }
                }
            }
        }
    }

    /**
     * 计算面板按钮权限状态
     *
     * @public
     * @memberof AppLoginViewBase
     */
    public computeButtonAuthState() {
        Object.values(this.layoutModelDetails).forEach((layoutModel: any) => {
            if (layoutModel.itemType == 'BUTTON') {
                layoutModel.computeActionAuthState();
            }
        })
    }

    /**
     * 处理值改变
     *
     * @public
     * @params args 改变数据
     * @params index 多数据容器下标
     * @memberof AppLoginViewBase
     */
    public handleValueChange(args: { name: string, value: any }, index?: number) {
        if (!args || !args.name || Object.is(args.name, '') || !this.layoutData.hasOwnProperty(args.name)) {
            return;
        }
        const {name,value} = args;
        this.layoutData[name] = value;
        this.layoutModelDetails[name].setData(value);
        this.panelLogic(name, index);
        this.computeButtonAuthState();
    }


    /**
     * 面板逻辑
     *
     * @public
     * @params name 改变项名称
     * @params index 多数据容器下标
     * @memberof AppLoginViewBase
     */
    public panelLogic(name: string, index?: number): void {
        if (name && (index || index === 0)) {
            name = name.replace(`_${index}`,"");
        }
    }

    /**
     * 处理按钮点击
     *
     * @public
     * @memberof AppLoginViewBase
     */
    public handleButtonClick(name: string, $event?: any) {
        let datas: any[] = [];
        const data: any = this.layoutModelDetails[name].getData();
        if (data) {
            if (data instanceof Array) {
                datas = [...data];
            } else {
                datas = [data];
            }
        }
        const xData: any = this.layoutModelDetails[name].getDataArea();
        const paramJO: any = {};
        const contextJO: any = {};
        const _this: any = this;
        if (Object.is(name, 'auth_loginbutton1')) {
            _this.panel_Usr1102196415_auth_loginbutton1_click(datas, contextJO, paramJO,  $event, xData, this, undefined);
        }
        if (Object.is(name, 'auth_resetinput1')) {
            _this.panel_Usr1102196415_auth_resetinput1_click(datas, contextJO, paramJO,  $event, xData, this, undefined);
        }
        if (Object.is(name, 'auth_logout1')) {
            _this.panel_Usr1102196415_auth_logout1_click(datas, contextJO, paramJO,  $event, xData, this, undefined);
        }
    }

    /**
     * 登陆
     *
     * @param {any[]} args 当前数据
     * @param {any} contextJO 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName]  父实体名称
     */
    public panel_Usr1102196415_auth_loginbutton1_click(args: any[], contextJO?:any, params?: any, $event?: any, xData?: any, actionContext?:any, srfParentDeName?:string) {
        if (this.viewType === 'APPLOGINVIEW') {
            const layoutData = args.length > 0 ? args[0] : {};
            const layoutModelDetails: any = this.layoutModelDetails || {};
            let userNameKey: string = Object.keys(layoutModelDetails).find((key: string) => Object.is(layoutModelDetails[key].predefinedType, 'AUTH_USERID')) || '';
            let passwordKey: string = Object.keys(layoutModelDetails).find((key: string) => Object.is(layoutModelDetails[key].predefinedType, 'AUTH_PASSWORD')) || '';
            let messageKey: string = Object.keys(layoutModelDetails).find((key: string) => Object.is(layoutModelDetails[key].predefinedType, 'AUTH_LOGINMSG')) || '';
            if (!userNameKey || !passwordKey) {
                if (messageKey) {
                    this.handleValueChange({ name: messageKey, value: '用户名或密码未配置！' });
                } else {
                    this.$message({ message: '用户名或密码未配置！',type: 'warning'});
                }
                return;
            }
            const loginname: any = layoutData[userNameKey];
            const password: any = layoutData[passwordKey];
            if (!loginname || !password) {
                if (messageKey) {
                    this.handleValueChange({ name: messageKey, value: '请输入用户名与密码' });
                } else {
                    this.$message({ message: '请输入用户名与密码',type: 'warning'});
                }
                return;
            }
            // 清除cookie
            let leftTime = new Date();
            leftTime.setTime(leftTime.getSeconds() - 1000);
            document.cookie = "ibzuaa-token=;expires=" + leftTime.toUTCString();
            const data = { loginname, password };
            const post: Promise<any> = this.$http.post('/v7/login', data, true);
            post.then((response: any) => {
                if (response && response.status === 200) {
                    const data = response.data;
                    if (data && data.token) {
                        localStorage.setItem('token', data.token);
                        Util.setCookie('ibzuaa-token',data.token,0);
                    }
                    if(data && data.user){
                        localStorage.setItem('user', JSON.stringify(data.user));
                    }
                    // 设置cookie,保存账号密码7天
                    Util.setCookie("loginname",loginname, 7);
                    // 跳转首页
                    const url: any = this.$route.query.redirect ? this.$route.query.redirect : '*';
                    this.$router.push({path: url});
                }
            }).catch((error: any) => {
                // 登录提示
                const data = error.data;
                if (data) {
                    if (messageKey) {
                        this.handleValueChange({ name: messageKey, value: data.message || this.$t('components.login.loginfailed') });
                    }
                }
            });
        } else {
            this.$router.push({ path: "/login", query: { redirect: window.location.hash.replace("#", '') } });
        }
    }
    /**
     * 重置
     *
     * @param {any[]} args 当前数据
     * @param {any} contextJO 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName]  父实体名称
     */
    public panel_Usr1102196415_auth_resetinput1_click(args: any[], contextJO?:any, params?: any, $event?: any, xData?: any, actionContext?:any, srfParentDeName?:string) {
        if (this.viewType === 'APPLOGINVIEW') {
            const length = Object.keys(this.layoutData).length;
            for (let i = length - 1; i >= 0; i--) {
                const name = Object.keys(this.layoutData)[i];
                if (this.layoutData.hasOwnProperty(name) && !Object.is(this.layoutModelDetails[name].itemType, 'CONTAINER')) {
                    this.handleValueChange({ name, value: null });
                }
            }
            this.$nextTick(() => {
                this.$forceUpdate();
            })
        } else {
            const parentRef: any = this.$parent;
            if (parentRef.closeView && (parentRef.closeView instanceof Function)) {
                parentRef.closeView(args);
            } else if (this.closeView && (this.closeView instanceof Function)) {
                this.closeView(args);
            }
        }
    }
    /**
     * 登出
     *
     * @param {any[]} args 当前数据
     * @param {any} contextJO 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName]  父实体名称
     */
    public panel_Usr1102196415_auth_logout1_click(args: any[], contextJO?:any, params?: any, $event?: any, xData?: any, actionContext?:any, srfParentDeName?:string) {
        this.$Modal.confirm({
            title: '提示',
            content: '确认要退出登录？',
            okText: '确认',
            cancelText: '取消',
            onOk: () => {
                this.$http
                .get("/v7/logout")
                .then((response: any) => {
                    if (response && response.status === 200) {
                        localStorage.removeItem("user");
                        localStorage.removeItem("token");
                        let leftTime = new Date();
                        leftTime.setTime(leftTime.getSeconds() - 1);
                        document.cookie = "ibzuaa-token=;expires=" + leftTime.toUTCString();
                        this.$router.push({ path: "/login", query: { redirect: window.location.hash.replace("#", '') } });
                    }
                })
                .catch((error: any) => {
                    console.error(error);
                });
            }
        });
    }



    /**
     * 引擎初始化
     *
     * @public
     * @memberof AppLoginViewBase
     */
    public engineInit(): void {
    }

    /**
     * 应用导航服务
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public  navDataService = NavDataService.getInstance();

    /**
    * 导航服务事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof AppLoginViewBase
    */
    public serviceStateEvent: Subscription | undefined;

    /**
     * 门户部件状态对象
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    @Prop() public portletState?: any;

   /**
   * 门户部件状态事件
   *
   * @public
   * @type {(Subscription | undefined)}
   * @memberof AppLoginViewBase
   */
    public portletStateEvent: Subscription | undefined;

    /**
    * 门户部件状态事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof AppLoginViewBase
    */
    public formDruipartEvent: Subscription | undefined;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public context:any = {};

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public viewparams:any = {};

    /**
     * 视图缓存数据
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public viewCacheData:any;


    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof AppLoginViewBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 解析视图参数
     *
     * @public
     * @memberof AppLoginViewBase
     */
    public parseViewParam(inputvalue:any = null): void {
        for(let key in this.context){
            delete this.context[key];
        }
        if(this.$store.getters.getAppData() && this.$store.getters.getAppData().context){
            Object.assign(this.context,this.$store.getters.getAppData().context);
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            if(typeof this.viewdata == 'string') {
                Object.assign(this.context, JSON.parse(this.viewdata));
            }
            if(this.context && this.context.srfparentdename){
                Object.assign(this.viewparams,{srfparentdename:this.context.srfparentdename});
            }
            if(this.context && this.context.srfparentkey){
                Object.assign(this.viewparams,{srfparentkey:this.context.srfparentkey});
            }
            this.handleCustomViewData();
            return;
        }
        const path = (this.$route.matched[this.$route.matched.length - 1]).path;
        const keys: Array<any> = [];
        const curReg = this.$pathToRegExp.pathToRegexp(path, keys);
        const matchArray = curReg.exec(this.$route.path);
        let tempValue: Object = {};
        keys.forEach((item: any, index: number) => {
            if(matchArray[index + 1]){
                Object.defineProperty(tempValue, item.name, {
                    enumerable: true,
                    value: decodeURIComponent(matchArray[index + 1])
                });
            }
        });
        this.$viewTool.formatRouteParams(tempValue,this.$route,this.context,this.viewparams);
        this.handleCustomViewData();
        //初始化导航数据
        this.initNavDataWithRoute();
    }

    /**
     * 处理自定义视图数据
     *
     * @memberof AppLoginViewBase
     */
	public handleCustomViewData(){
		if(Object.keys(this.customViewNavContexts).length > 0){
			Object.keys(this.customViewNavContexts).forEach((item:any) =>{
				let tempContext:any = {};
				let curNavContext:any = this.customViewNavContexts[item];
				this.handleCustomDataLogic(curNavContext,tempContext,item);
				Object.assign(this.context,tempContext);
			})
		}
		if(Object.keys(this.customViewParams).length > 0){
			Object.keys(this.customViewParams).forEach((item:any) =>{
				let tempParam:any = {};
				let curNavParam:any = this.customViewParams[item];
				this.handleCustomDataLogic(curNavParam,tempParam,item);
				Object.assign(this.viewparams,tempParam);
			})
		}
	}

    /**
     * 处理自定义视图数据逻辑
     *
     * @memberof AppLoginViewBase
     */
	public handleCustomDataLogic(curNavData:any,tempData:any,item:string){
		// 直接值直接赋值
		if(curNavData.isRawValue){
			if(Object.is(curNavData.value,"null") || Object.is(curNavData.value,"")){
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: null,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }else{
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: curNavData.value,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }
		}else{
			// 先从导航上下文取数，没有再从导航参数（URL）取数，如果导航上下文和导航参数都没有则为null
			if(this.context[(curNavData.value).toLowerCase()] != null){
				Object.defineProperty(tempData, item.toLowerCase(), {
					value: this.context[(curNavData.value).toLowerCase()],
					writable : true,
					enumerable : true,
					configurable : true
				});
			}else{
				if(this.viewparams[(curNavData.value).toLowerCase()] != null){
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: this.viewparams[(curNavData.value).toLowerCase()],
						writable : true,
						enumerable : true,
						configurable : true
					});
				}else{
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: null,
						writable : true,
						enumerable : true,
						configurable : true
					});
				}
			}
		}
	}

    /**
     * 初始化导航数据(路由模式)
     *
     * @memberof AppLoginViewBase
     */
    public initNavDataWithRoute(data:any = null, isNew:boolean = false,  isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && Object.is(this.navModel,"route")) ){
            this.navDataService.addNavData({id:'app-login-view',tag:this.viewtag,srfkey:isNew ? null : null,title:this.$t(this.model.srfCaption),data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath});
        }
    }

    /**
     * 初始化导航数据(分页模式)
     *
     * @memberof AppLoginViewBase
     */
    public initNavDataWithTab(data:any = null,isOnlyAdd:boolean = true, isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && !Object.is(this.navModel,"route")) ){
            this.navDataService.addNavDataByOnly({id:'app-login-view',tag:this.viewtag,srfkey:null,title:this.$t(this.model.srfCaption),data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath},isOnlyAdd);
        }
    }
	

    /**
     * Vue声明周期
     *
     * @memberof AppLoginViewBase
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     * @memberof AppLoginViewBase
     */    
    public afterCreated(){
        let _this:any = this;
        const secondtag = _this.$util.createUUID();
        _this.$store.commit('viewaction/createdView', { viewtag: _this.viewtag, secondtag: secondtag });
        _this.viewtag = secondtag;
        _this.parseViewParam();
        _this.serviceStateEvent = _this.navDataService.serviceState.subscribe(({ action,name, data }:{ action:string,name:any,data:any }) => {
            if(!Object.is(name,'app-login-view')){
                return;
            }
            if (Object.is(action, 'viewrefresh')) {
                _this.$nextTick(()=>{
                    _this.parseViewParam(data);
                    if(_this.engine){
                        _this.engine.load();
                    }
                }); 
            }
        });
        if(_this.portletState){
            _this.portletStateEvent = _this.portletState.subscribe((res:any) =>{
                if(!Object.is(res.name,'AppLoginView')){
                    return;
                }
                if(Object.is(res.action,'refresh') && _this.refresh && _this.refresh instanceof Function){
                    _this.refresh();
                }
            })
        }
        _this.initViewCtx();
    }

    /**
     * 初始化视图操作参数
     *
     * @memberof AppLoginViewBase
     */  
    initViewCtx() {
        Object.assign(this.viewCtx, {
            app: this.$root,
            view: this,
            viewGlobal: {},
            viewNavData: {},
            viewNavContext: this.context,
            viewNavParam: this.viewparams,
            messagebox: AppMessageBox.getInstance(),
        });
        Object.assign(this.viewCtx, { appGlobal: this.$store.getters.getAppGlobal() });
        if (this.$store.getters.getRouteViewGlobal(this.context.srfsessionid)) {
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        } else {
            this.$store.commit('addRouteViewGlobal', { tag: this.context.srfsessionid, param: {} });
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            //  嵌入视图
            Object.assign(this.viewCtx, {
                topview: this.$store.getters.getView(this.context.srfsessionid)
            });
        } else {
            //  顶层视图
            this.$store.commit('addView', { tag: this.context.srfsessionid, param: this });
            Object.assign(this.viewCtx, { topview: this });
        }
    }

    /**
     * 销毁之前
     *
     * @memberof AppLoginViewBase
     */
    public beforeDestroy() {
        this.$store.commit('viewaction/removeView', this.viewtag);

        let _this: any = this
        if (_this.serviceStateEvent) {
            _this.serviceStateEvent.unsubscribe();
        }
        if (_this.portletStateEvent) {
            _this.portletStateEvent.unsubscribe();
        }
        if (_this.engine) {
            _this.engine.destroy();
        }
    }

    /**
     * Vue声明周期(组件初始化完毕)
     *
     * @memberof AppLoginViewBase
     */
    public mounted() {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     * 
     * @memberof AppLoginViewBase
     */
    public afterMounted(){
        const _this: any = this;
        _this.initLayout().then((result: any) => {
            _this.isLayoutLoadding = false;
            _this.engineInit();
            if (_this.loadModel && _this.loadModel instanceof Function) {
                _this.loadModel();
            }
        })
    }




    /**
     * 关闭视图
     *
     * @param {any[]} args
     * @memberof AppLoginViewBase
     */
    public closeView(args: any[]): void {
        let _view: any = this;
        if (_view.viewdata) {
            _view.$emit('viewdataschange', Array.isArray(args)?args:[args]);
            _view.$emit('close', Array.isArray(args)?args:[args]);
        } else if (_view.$tabPageExp) {
            _view.$tabPageExp.onClose(_view.$route.fullPath);
        }
    }

    /**
     * 应用名称
     *
     * @type {string}
     * @memberof AppLoginViewBase
     */
    public appTitle: string = Environment.AppTitle;

    /**
     * 登录数据对象
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public formData: any = {
        loginname: '',
        password: ''
    }

    /**
    * 登录提示
    *
    * @type {*}
    * @memberof AppLoginViewBase
    */
    public loginTip: any = "";

    /**
     * 值规则
     *
     * @type {*}
     * @memberof AppLoginViewBase
     */
    public rules = {
        loginname: [
            {required: true, message: this.$t('components.login.loginname.message'), trigger: 'change'},
        ],
        password: [
            {required: true, message: this.$t('components.login.password.message'), trigger: 'change'},
        ],
    };

    /**
     * 登陆处理
     *
     * @memberof AppLoginViewBase
     */
    public handleSubmit(): void {
        // 清除cookie
        let leftTime = new Date();
        leftTime.setTime(leftTime.getSeconds() - 1000);
        document.cookie = "ibzuaa-token=;expires=" + leftTime.toUTCString();
        const form: any = this.$refs.loginForm;
        let validatestate: boolean = true;
        form.validate((valid: boolean) => {
            validatestate = valid ? true : false;
        });
        if (!validatestate) {
            return;
        }
        const loginname: any = this.formData.loginname;
        const password: any = this.formData.password;
        const post: Promise<any> = this.$http.post('/v7/login', this.formData, true);
        post.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                if (data && data.token) {
                    localStorage.setItem('token', data.token);
                    Util.setCookie('ibzuaa-token',data.token,0);
                }
                if(data && data.user){
                    localStorage.setItem('user', JSON.stringify(data.user));
                }
                // 设置cookie,保存账号密码7天
                Util.setCookie("loginname",loginname, 7);
                // 跳转首页
                const url: any = this.$route.query.redirect ? this.$route.query.redirect : '*';
                this.$router.push({path: url});
            }
        }).catch((error: any) => {
            // 登录提示
            const data = error.data;
            if (data && data.message) {
                this.loginTip = data.message;
                this.$Message.error({
                    content: (this.$t('components.login.loginfailed') as string)+' ' + data.message,
                    duration: 5,
                    closable: true
                });
            } else {
                this.$Message.error({
                    content: (this.$t('components.login.loginfailed') as string),
                    duration: 5,
                    closable: true
                });
            }
        });
    }

    /**
     * 重置页面
     * 
     * @memberof AppLoginViewBase
     */
    public goReset(): void {
        this.formData = {loginname: 'ibzadmin', password: '123456'};
    }

    /**
     * qq授权登录
     * @param AppLoginViewBase
     */
    public tencentHandleClick() {
        this.$Message.warning((this.$t('components.login.warning1') as string))
    }

    /**
     * 微信授权登录
     * @param AppLoginViewBase
     */
    public wechatHandleClick() {
        this.$Message.warning((this.$t('components.login.warning2') as string))
    }

}
</script>

<style lang='less'>
@import './app-login-view.less';
</style>